From 693484e44e7eb6cc385a7050817b4a070d11345d Mon Sep 17 00:00:00 2001
From: Alyssa Rosenzweig <alyssa@rosenzweig.io>
Date: Thu, 17 Nov 2022 17:44:27 -0500
Subject: [PATCH] for jannau

Signed-off-by: Alyssa Rosenzweig <alyssa@rosenzweig.io>
---
 src/gallium/drivers/asahi/agx_pipe.c | 7 ++++---
 1 file changed, 4 insertions(+), 3 deletions(-)

diff --git a/src/gallium/drivers/asahi/agx_pipe.c b/src/gallium/drivers/asahi/agx_pipe.c
index 83ad812a8d0..b4509247716 100644
--- a/src/gallium/drivers/asahi/agx_pipe.c
+++ b/src/gallium/drivers/asahi/agx_pipe.c
@@ -169,10 +169,13 @@ agx_resource_from_handle(struct pipe_screen *pscreen,
    if (!rsc)
       return NULL;
 
+   rsc->modifier = whandle->modifier == DRM_FORMAT_MOD_INVALID ?
+                   DRM_FORMAT_MOD_LINEAR : whandle->modifier;
+
    /* We need strides to be aligned. ail asserts this, but we want to fail
     * gracefully so the app can handle the error.
     */
-   if ((whandle->stride % 16) != 0)
+   if (rsc->modifier == DRM_FORMAT_MOD_LINEAR && (whandle->stride % 16) != 0)
       return false;
 
    prsc = &rsc->base;
@@ -191,8 +194,6 @@ agx_resource_from_handle(struct pipe_screen *pscreen,
             return NULL;
    }
 
-   rsc->modifier = whandle->modifier == DRM_FORMAT_MOD_INVALID ?
-                   DRM_FORMAT_MOD_LINEAR : whandle->modifier;
    agx_resource_setup(dev, rsc);
 
    if (rsc->layout.tiling == AIL_TILING_LINEAR)
-- 
2.35.1

